<div class="wrap">
	<h2><?php _e('Fancy News - Shortcode Builder', 'radykal'); ?></h2>
	<form id="fn-shortcode-builder-form" class="fn-clearfix">
		<div id="fn-content" class="fn-clearfix">
			<h3><?php _e('Set the content', 'radykal'); ?></h3>
			<fieldset>
				<label><input type="radio" name="post_feed" value="post" checked="checked" /> <?php _e('Post', 'radykal'); ?></label>
				<label><input type="radio" name="post_feed" value="feed" /> <?php _e('RSS feed', 'radykal'); ?></label>
			</fieldset>
			<div id="content-post-wrapper">
				<div>
					<h4><?php _e('Select the post type', 'radykal'); ?></h4>
					<select id="fn-post-type">
						<?php
						$post_types = get_post_types( array( 'public' => true), 'objects' );
						foreach ( $post_types as $post_type ) {
							if($post_type->name != 'page')
						    	echo '<option value="'.$post_type->name.'">' .$post_type->labels->name. '</option>';
						}
						?>
					</select>
					<br /><br />
					<h4><?php _e('Select a taxonomy', 'radykal'); ?> *</h4>
					<select id="fn-taxonomies">
						<option value="fn-none"><?php _e('None', 'radykal'); ?></option>
					</select>
					<div id="fn-ajax-loader"></div>
				</div>
				<div>
					<h4><?php _e('Select one or more terms', 'radykal'); ?></h4>
					<div id="fn-terms"></div>
				</div>
			</div>
			<div id="content-feed-wrapper">
				<h4><?php _e('Set the RSS feed URL', 'radykal'); ?></h4>
				<input type="text" id="fn-feed-url" value="" size="50" />
				<br /><br />
				<h4><?php _e('Set an API key. Get one from here:', 'radykal'); ?> <a href="https://rss2json.com" target="_blank">https://rss2json.com</a></h4>
				<input type="text" id="fn-rss-api-key" value="" size="50" />
			</div>
		</div>
		<div id="fn-options" class="fn-clearfix">
			<h3><?php _e('Options', 'radykal'); ?></h3>
			<div>
				<div class="fn-clearfix">
					<label><span><?php _e('Amount of posts', 'radykal'); ?>:</span><input type="text" size="5" name="amount" value="-1" class="fn-text" data-default="-1" /></label>
					<span class="description"><?php _e('To load all posts, just set it to -1. For RSS feed you need to set an absolute value.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Width', 'radykal'); ?>:</span><input type="text" size="5" name="width" value="500px" class="fn-text" data-default="500px" /></label>
					<span class="description"><?php _e('In pixels or percentage.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Height', 'radykal'); ?>:</span><input type="text" size="5" name="height" value="600" class="fn-text" data-default="600" /></label>
					<span class="description"><?php _e('In pixels.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Offset', 'radykal'); ?>:</span><input type="text" size="5" name="offset" value="3" class="fn-text" data-default="3" /></label>
					<span class="description"><?php _e('Offset between the excerpts in px.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Excertps per stack', 'radykal'); ?>:</span><input type="text" size="5" name="excertps_per_page" value="3" class="fn-text"  data-default="3" /></label>
					<span class="description"><?php _e('The number of excerpts that should be displayed at once.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Slide time', 'radykal'); ?>:</span><input type="text" size="5" name="slide_time" value="" class="fn-text"  data-default="" /></label>
					<span class="description"><?php _e('The slide time in ms. Setting a value for it, will enable the auto-sliding.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Excerpt End', 'radykal'); ?>:</span><input type="text" name="excerpt_end" value="[....]" class="fn-text"  data-default="[....]" /></label>
					<span class="description"><?php _e('The text that will be appended at the end of the excerpt.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Background Color', 'radykal'); ?>:</span><input type="text" size="5" name="background_color" class="fn-colorpicker" value="#ECF0F1" data-default="#ECF0F1" /></label>
					<span class="description"><?php _e('The background color.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Background Color Hover', 'radykal'); ?>:</span><input type="text" size="5" name="background_color_hover" class="fn-colorpicker" value="#F3F8F9" data-default="#F3F8F9" /></label>
					<span class="description"><?php _e('The background color on hover.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Text Color', 'radykal'); ?>:</span><input type="text" size="5" name="text_color" class="fn-colorpicker" value="#333333" data-default="#333333" /></label>
					<span class="description"><?php _e('The text color.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Primary Color', 'radykal'); ?>:</span><input type="text" size="5" name="primary_color" class="fn-colorpicker" value="#7F8C8D" data-default="#7F8C8D" /></label>
					<span class="description"><?php _e('The primary color - Border, headlines, icons.', 'radykal'); ?></span>
				</div>

			</div>
			<div>
				<div class="fn-clearfix">
					<label><span><?php _e('Linking', 'radykal'); ?>:</span><input type="checkbox" value="no" name="linking" /></label>
					<span class="description"><?php _e('Will open the post in an own window and not in the slider.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Infinite Loop', 'radykal'); ?>:</span><input type="checkbox" name="infinite_loop" value="no" /></label>
					<span class="description"><?php _e('Enable the infinite loop when scrolling, it will also hide the post counter.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Arrows', 'radykal'); ?>:</span><input type="checkbox" name="arrows" value="yes" checked="checked" /></label>
					<span class="description"><?php _e('Show or hide the navigation arrows.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Vertical', 'radykal'); ?>:</span><input type="checkbox" name="vertical" value="no" /></label>
					<span class="description"><?php _e('Enable the vertical layout.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Center', 'radykal'); ?>:</span><input type="checkbox" name="center" value="no" /></label>
					<span class="description"><?php _e('Will center the slider.', 'radykal'); ?></span>
				</div>
				<div class="fn-clearfix">
					<label><span><?php _e('Target Window', 'radykal'); ?>:</span></label>
					<select name="target_window" class="fn-dropdown" data-default="_blank">
						<option value="_blank"><?php _e('New window', 'radykal'); ?></option>
						<option value="_self"><?php _e('Same window', 'radykal'); ?></option>
					</select>
					<span class="description"><?php _e('When linking is enabled, decide if the post should be opened in a new or in the same window.', 'radykal'); ?></span>
				</div>

			</div>
		</div>
	</form>
	<h4><?php _e('Copy the shortcode', 'radykal'); ?>:</h4>
	<textarea id="fn-shortcode"></textarea>
	<br />
	<span style="font-style: italic; font-size: 12px;">* <?php _e('optional', 'radykal'); ?></span>
	<script type="text/javascript">

		jQuery(document).ready(function($) {

			var $terms = $('#fn-terms'),
				$options = $('#fn-options'),
				$ajaxLoader = $('#fn-ajax-loader');

			$('input[name="post_feed"]').change(function() {

				console.log(this.value);
				if(this.value == 'post') {
					$('#content-post-wrapper').show();
					$('#content-feed-wrapper').hide();
				}
				else {
					$('#content-post-wrapper').hide();
					$('#content-feed-wrapper').show();
				}

			});

			$('.fn-colorpicker').spectrum({
				preferredFormat: "hex",
				showInput: true,
				chooseText: "<?php _e('Change Color', 'radykal'); ?>",
				change: function(color) {
					$('#fn-shortcode-builder-form').change();
				}
			});


			$('#fn-shortcode-builder-form').change(function() {

				var shortcodeStr = '[fancy_news ';

				if($('input[name="post_feed"]:checked').val() == 'post') {
					shortcodeStr += 'post_type="'+$('#fn-post-type').val()+'" ';

					if($taxonomySelect.val() != 'fn-none' && $terms.find('input:checked').size() > 0) {
						shortcodeStr += 'taxonomy="'+$taxonomySelect.val()+'" ';
					}
					if($terms.find('input:checked').size() > 0) {
						var termIds = '';
						$terms.find('input:checked').each(function(index, item) {
							termIds += item.value + ',';
						});
						shortcodeStr += 'terms="'+termIds.substring(0, termIds.length-1)+'" ';
					}
				}
				else {
					shortcodeStr += 'feed="'+$('#fn-feed-url').val()+'" ';
					shortcodeStr += 'api_key="'+$('#fn-rss-api-key').val()+'" ';
				}

				//text and numbers
				$options.find('.fn-text').each(function(index, item) {

					var $item = $(item),
						text = $item.val();

					if(text != $item.data('default') && text != '') {
						shortcodeStr += ''+item.name+'="'+text+'" ';
					}

				});

				//checkboxes
				$options.find('input[type="checkbox"]').each(function(index, item) {

					var $item = $(item),
						checked = $item.is(':checked') ? 'yes' : 'no';

					if(item.value != checked) {
						shortcodeStr += ''+item.name+'='+checked+' ';
					}

				});

				//colors
				$options.find('.fn-colorpicker').each(function(index, item) {

					var $item = $(item),
						hex = $item.val();

					if(hex != $item.data('default')) {
						shortcodeStr += ''+item.name+'='+hex+' ';
					}

				});

				//dropdowns
				$options.find('.fn-dropdown').each(function(index, item) {

					var $item = $(item),
						value = $item.val();

					if(value != $item.data('default')) {
						shortcodeStr += ''+item.name+'='+value+' ';
					}

				});

				shortcodeStr += ']';

				$('#fn-shortcode').val(shortcodeStr);

			});

			var $taxonomySelect = $('#fn-taxonomies').change(function() {

				$terms.hide().empty().prev('h4').hide();

				if(this.value == 'fn-none') {
					return false;
				}

				$ajaxLoader.css('visibility', 'visible');
				$.ajax({
					url: "<?php echo admin_url('admin-ajax.php'); ?>",
					data: { action: 'get_terms', _ajax_nonce: "<?php echo $this->ajax_nonce; ?>", taxonomy: this.value },
					type: 'post',
					dataType: 'json',
					success: function(data) {

						$ajaxLoader.css('visibility', 'hidden');

						if(data === 0) {
							alert("<?php _e( 'Terms could not be loaded. Please try again!', 'radykal' ); ?>");
						}
						else {
							for (var key in data) {
								$terms.append('<label><input type="checkbox" name="fn_term" value="'+data[key]+'" />'+key+'</label>');
							}

							if($terms.children().size() > 1) {
								$terms.show().prev('h4').show();
							}

						}

					}
				});

			});

			$('#fn-post-type').change(function() {

				$taxonomySelect.hide().children('option').not('[value="fn-none"]').remove();
				$taxonomySelect.prev('h4').hide();
				$terms.hide().empty().prev('h4').hide();

				$ajaxLoader.css('visibility', 'visible');
				$.ajax({
					url: "<?php echo admin_url('admin-ajax.php'); ?>",
					data: { action: 'get_taxonomies', _ajax_nonce: "<?php echo $this->ajax_nonce; ?>", post_type: this.value },
					type: 'post',
					dataType: 'json',
					success: function(data) {

						$ajaxLoader.css('visibility', 'hidden');

						if(data === 0) {
							alert("<?php _e( 'Taxonomies could not be loaded. Please try again!', 'radykal' ); ?>");
						}
						else {
							for (var key in data) {
								$taxonomySelect.append('<option value="'+key+'">'+data[key]+'</option>');
							}

							if($taxonomySelect.children().size() > 1) {
								$taxonomySelect.show().change();
								$taxonomySelect.prev('h4').show();
							}

						}

					}
				});

			}).change();

		});

	</script>
</div>